﻿unit SEARCHPRODUCTS;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.Filectrl,
  Vcl.ComCtrls, Vcl.StdCtrls;
type
  TForm1 = class(TForm)
    Panel1: TPanel;
    butPathPc: TButton;
    edErrCode: TEdit;
    edPfad: TEdit;
    butExecute: TButton;
    Label1: TLabel;
    Label2: TLabel;
    memInfo: TMemo;
    edGefFan: TEdit;
    comBoxIdNo: TComboBox;
    comBoxTyp: TComboBox;
    butGetProducts: TButton;
    Panel2: TPanel;
    btSearchProducts: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    memSearchProducts: TMemo;
    edErrCodeSearchProducts: TEdit;
    edAirVolume: TEdit;
    edPressuredifference: TEdit;
    edTolerance: TEdit;
    edAirDdensity: TEdit;
    edwidth: TEdit;
    edheight: TEdit;
    Timer1: TTimer;
    procedure butPathPcClick(Sender: TObject);
    procedure butExecuteClick(Sender: TObject);
    procedure show_Results(n: Integer; Path : string);
    function setPath(Path: AnsiString): Integer;
    procedure butGetProductsClick(Sender: TObject);
    procedure Clear_display;
    procedure List_item;
    procedure show_Results_2(n:Integer; FanList:String);
    procedure btSearchProductsClick(Sender: TObject);
    function list_item_search_Products : integer;
    procedure check_search_products;
    procedure show_Result_search_products_Data(OutputString:PAnsichar);
    procedure comBoxIdNoChange(Sender: TObject);
    procedure comBoxTypChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Delay(const Milliseconds: DWord);


  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
uses uDLLdef;
{$R *.dfm}


{===============================================================================}
procedure TForm1.butExecuteClick(Sender: TObject);
var
  BuPath: string;
  mbYesNo: Integer;
  selDirect: boolean;
  vBuPath: string;
begin
  // Call the Directory// Directory aufrufen
  selDirect := SelectDirectory('Wählen Sie den gewünschten Pfad aus.', '', BuPath);
  // If not true close the Window // Wenn nicht wahr, Fenster schließen
  if not selDirect then
  begin
    Exit;
  end
  else
  // Open the FolderBrowserDialog // FolderBrowserDialog öffnen
  begin
    vBuPath := 'Wollen Sie den Pfad:  ' + BuPath + #13 + 'übernehmen?';
    mbYesNo := MessageDlg(vBuPath, mtConfirmation, [mbYes, mbNo], 0);
    // if 'Yes' write the path in the variable and show it in the Editbox// wenn 'Ja' Pfad in Variable schreiben und in Edit-Feld anzeigen
    if mbYesNo = ID_YES then
    begin
      edPfad.Text := BuPath
    end
    else
    // if no stop the process and show a message// Wenn 'Nein' Verarbeitung stoppen, Fehlermeldung ausgeben
    begin
      application.messageBox('Die Verarbeitung wurde abgebrochen!', ' ', 0);
    end;

  end;

end;
{===============================================================================}
procedure TForm1.butPathPcClick(Sender: TObject);
var
  Path: AnsiString;
  n: LongInt;                  // n = number of the error code 0 = file is available -1 = file is not available // n = Nummer des Error Codes 0 = file ist verfügbar -1 = file ist nicht verfügbar
begin

    Path := trim(edPfad.Text); // Trim the content of the Editbox to look for the path // Trimme den Inhalt der Editbox um nach den Pfad nachschauen zu können
    n := setPath(Path);

    // if the file doesn´t exist show a Message // Wenn die File nicht existiert, zeige eine Benachrichtigung an
    if not DirectoryExists(edPfad.Text) then

    ShowMessage('Pfad existiert nicht! Bitte wählen sie einen gültigen Pfad!');
end;
{===============================================================================}
procedure TForm1.show_Results(n: Integer; Path: string);
var
  l: LongInt;           // l = length of the path string (number of signs) // l = die Länge des Pfad Strings (Anzahl der Zeichen)
begin

  l := length(Path);   // Set the length of the path // Setze die Länge des Pfads
  if Path[l] = ';' then  // if there is a semcolon at the end // Wenn ein Semikolon am Ende steht
    delete(Path, l, 1);  // delete it // lösche es
  if fileExists(Path + '\Data.sqlite') then // if the file Data.sqlite exists edErrCode will show 0 // Wenn die file Data.sqlite existiert wird edErrCode eine 0 anzeigen
  begin
    edPfad.Text := Path;
    edErrCode.Text := intToStr(n);
  end
  else    // if not edErrCode will show -1 // wenn nicht, wird edErrCode eine -1 anzeigen
  begin
    edErrCode.Text := intToStr(-1);
    edPfad.Text := 'keine Datenbank vorhanden!  ' + Path + '\Data.sqlite'
  end;
end;
{===============================================================================}
function TForm1.setPath(Path: AnsiString): Integer;
var
  l, n: LongInt;
  path_PAnsiChar: PAnsiChar;
  buffer: PAnsiChar;
begin
  n := -1;
  if fileExists(Path + '\Data.sqlite') then  // if the file Data.sqlite exists  // Wenn die file Data.sqlite existiert
  begin
    l := length(Path);                       // Set the length // Setze die Länge
    if Path[l] <> ';' then                   // if there is no semicolon at the end // Wenn kein Semikolon am Ende steht
    Path := Path + ';';                      // Add a semicolon // Füge ein Semikolon hinzu
    GetMem(buffer, 4000);                    // Get Free Memory for the function // Hole freien Speicher für die Funktion
    buffer := PAnsiChar(Path);               // write the path in the variable buffer (in Ansi code) // schreibe den Pfad in die Variable buffer (im Ansicode)
    n := uDLLdef.SET_XML_PATH_PC(buffer);    // integrate the database with the program // Binde die Datenbank in das Programm ein
    show_Results(n, buffer);                 // show the result // zeige das Ergebnis
  end
  else
  begin
    result := n;
  end;
end;
{===============================================================================}
procedure TForm1.butGetProductsClick(Sender: TObject);
begin
  if edErrCode.Text = '0' then
  begin
  List_item;        // list the itmes // Liste die Daten auf
  end;
end;
{===============================================================================}
procedure TForm1.Clear_display;
begin
  memInfo.Clear;    // delete the content of  memInfo // Lösche den Inhalt von memInfo
  comBoxIdNo.Clear; // delete the content of comBoxIdNo // Lösche den Inhalt von comBoxIdNo
  comBoxTyp.Clear;  // delete the content of comBoxTyp // Lösche den Inhalt von ComBoxTyp
end;

{===============================================================================}
procedure TForm1.comBoxIdNoChange(Sender: TObject);
var
n : integer;
begin
  n := comBoxIdNo.ItemIndex;
  comBoxTyp.ItemIndex := n;
end;
{===============================================================================}
procedure TForm1.comBoxTypChange(Sender: TObject);
var
n : integer;
begin
  n := comBoxTyp.ItemIndex;
  comBoxIdNo.ItemIndex := n;
end;
{===============================================================================}
procedure TForm1.List_item;
var
  fanDescription: PAnsiChar;
  n:integer;
  FanList:String;
begin
  Clear_display;                                    // Clear the contents // Lösche die Inhalte

                                                    // PC PAnsiChar // PC AnsiChar
      GetMem(fanDescription, 4000);                 // Get free Memor for the function // Hole freien Speicher für die Funktion
      n:=uDLLdef.GET_PRODUCTS_PC(fanDescription);   // Get the Products(PC) // Hole die Produkte
      show_Results_2(n,fanDescription);             // Show the result in the Combobexes and the Memo // Zeige das Ergebnis in den Comboboxen und in der Memo
      FreeMem(fanDescription);                      // free the Memory // Gebe den Speicher frei



end;
{===============================================================================}
procedure TForm1.show_Results_2(n:Integer;       //Number of products // Anzahl der Produkte
                                          FanList:String);  //Product List // Produktliste


var
  Typen:             Array of String; // Declaration of a string array for the types // Deklaration eines string Arrays für die Typen
  IdNo :             Array of String; // Declaration of a string array for the ID // Deklaration eines string Arrays für die ID

  m,Anz:integer;                       // Declaration of the variable m for the number of signs after a '|' // Deklaration der Variable m für die Anzahl der Zeichen nach einem '|'
  s:String;                            // Declaration of the variable s for the product list // Deklaration der Variable s für die Produktliste
begin
  SetLength(Typen,n+1);
  SetLength(IdNo,n+1);
  edGefFan.Text:= IntToStr(n);
  s:=FanList; {übergebener String merken}
  Anz:=0;    //Number of types //Anzahl der Typen
  while Pos(';',S) > 0 do begin    //  Semicolon in | convert and count // Wandle Semikolon zu | um und zähle hoch
    m:=Pos(';',S);                 //position of the semicolon  // Position des Semikolons
    S[m]:= '|';
    inc(Anz);
  end;


    memInfo.Lines.Add('number of existing ventilators: '+intToStr(Anz div 2)); // show the number of elements // Zeige die Anzahl der Elemente an

  n:=1;
  while length(s)>0 do begin       // While the length is > 0 // Während die Länge > 0 ist
    m:=pos('|',s);
    idno[n]:=copy(s,1,m-1);        // Copy the ID to the idno array // Kopiere die ID in das idno Array
    delete(s,1,m);                 // Delete the ID in the string // Lösche die ID in dem string
    s:=trim(s);                    // Trim the string  // Trimme den String

    m:=pos('|',s);
    Typen[n]:=copy(s,1,m-1);       // Copy the type to the type array // Kopiere die Typen in das Typen Array
    delete(s,1,m);                 // Delete the type int the string // Lösche den Typ in den string
    s:=trim(s);                    // Trim the string // Trimme den String



    memInfo.Lines.Add('No: '+intToStr(n)+'   '+idno[n]+'   '+Typen[n]); // Fill the Memo with the information // Fülle die Memo mit Informationen
    comBoxIdNo.Items.Add(IdNo[n]);  // Fill the ID ComboBox with the information // Fülle die ID ComboBox mit Informationen
    comBoxTyp.Items.Add(Typen[n]);  // Fill the type ComboBOx with the information // Fülle die Typ ComboBox mit Informationen
    inc(n);
  end;
  if comBoxIdNo.Items.Count>0   then comBoxIdNo.ItemIndex:=0; //Show the ID of the first product // Zeige die ID vom ersten Produkt
  if comBoxTyp.Items.Count>0    then comBoxTyp.ItemIndex:=0;  //Show the type of the first product // Zeige den Typ des ersten Produkts
end;
{===============================================================================}
procedure TForm1.show_Result_search_products_Data(OutputString:PAnsichar);

  var
tmpDescript : Array[0..5] of String;   // String for copying the data // String um die Datenwerte zu kopieren
tempDescript: String;
i : integer;            // Counter variable // Zählvariable
m : integer;            // Integer to show the index of the first semikolon in the string // Integer um den Index des ersten Semikolon in dem String anzuzeigen
s : String;             // String for copying the whole data in it // String um die ganzen Daten zu kopieren
Sign : String ;         // String for the Seperator
j : integer;
line : integer;
begin

for i := 0 to 5 do
begin
tmpDescript[i]:= '';                  // Delete the content // Lösche den Inhalt
end;
tempDescript := '';
i := 0;
j := 0;
memSearchProducts.Lines.Clear;  // Delete the list // Lösche die Liste
  line := 0;
  s :=  OutputString;
  inc(i);
  memSearchProducts.Lines.Add('IdNo' + #09 + #09 + 'Typ' + #09 +#09+ 'n [1/min]' + #09 +#09+ 'Pe [W]' + #09 +#09+ 'ηe[%]' + #09 +#09+ 'ErrorCode' );
  inc(line);
  while ((Length(s) > 0)) do begin  // As long as the Length is bigger than 0 // Solange die Länge größer 0 ist
    m:=pos(';',s);
    if s[i] <>  ';' then           //if there is no semicolon add the Sign to tempDescript // Wenn kein Semikolon, dann füge das Zeichen zu tmpDescript hinzu
    begin
      tempDescript:= tempDescript + s[i];
      inc(i);
    end
    else  // If there is a separator add the Data to the list // Wenn ein Seperator vorhanden füge die Datenwerte in der Liste hinzu
    begin

      tmpDescript[j] := tempDescript;
      Delete(s,1,m); // Delete the Data that was copied in the string  // Lösche den Datenwert, der kopiert wurde, in dem String
      trim(s);  // Trim it // Trimme es
      i := 1;
      inc(j);
      tempDescript := '';
      if j = 6 then
      begin

        memSearchProducts.lines.Add(tmpDescript[0] + #09 + #09 + tmpDescript[1] +#09+ tmpDescript[2] + #09 +#09+ tmpDescript[3] + #09+#09 + tmpDescript[4] + #09+#09 + tmpDescript[5]);

        j := 0;
      end;
    end;
  end;
end;




{===============================================================================}
function TForm1.list_item_search_Products : integer;
var
n : integer;                       // Counter variable // Zählvariable
InputString,OutputString : PAnsiChar;    // Input and Output for the function // Input und Output für die Funktion
Input : AnsiString;
begin
n := 99;
GetMem(OutputString,4000);  // Get Memory for the function // Hole Speicher für die Funktion
Input := edAirVolume.Text + ';' + edPressuredifference.Text + ';' + edTolerance.Text + ';' + edAirDdensity.Text + ';' + edwidth.Text + ';' + edheight.Text + ';';  // Fill the Input with the Data in the Edit boxes // Fülle den Input mit den Daten in den Edit Boxen
InputString := PAnsichar(Input);
n := SEARCH_PRODUCTS(InputString,OutputString); // Search for the Products // Suche nach den geeigneten Produkten
show_Result_search_products_Data(OutputString); // Show the products // Zeige die Produkte an
FreeMem(OutputString);                          // Free the memory // Gib den Speicher frei
result := n;


end;
{===============================================================================}
procedure TForm1.check_search_products;
var
density : double;
begin
  //When number of elements is not empty and error code is 0, then proceed // Wenn die Anzahl der Elemente nicht leer ist und der Error Code = 0, fahre fort
   if (edGefFan.Text <> '') and (edErrCode.Text ='0') then
   begin

     try
      density := StrToFloat(edAirDdensity.Text);
      except
      ShowMessage('density not numerary!');

      end;
      if (density > 1.46) or (density < 0.59) then
    begin
    ShowMessage('Density not valid! Allowed values are from [0.6] to [1.45]. For floating values please check if you´ve wrote a comma [,] or dot [.] according to your region!');
    end
    else
    begin
     edErrCodeSearchProducts.Text := IntToStr(list_item_Search_Products);
    end;
   end
   else
   begin


   end;
end;
{===============================================================================}
procedure TForm1.btSearchProductsClick(Sender: TObject);
begin
   check_search_products; // Check whether you can click search products // Überprüfe, ob man überhaupt search products klicken kann
end;

procedure TForm1.Delay(const Milliseconds: DWord);
var
  FirstTickCount: DWord;
begin
  FirstTickCount := GetTickCount;
  while ((GetTickCount - FirstTickCount) < Milliseconds) do
    Application.ProcessMessages;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  Path: AnsiString;
  n: LongInt;                  // n = number of the error code 0 = file is available -1 = file is not available // n = Nummer des Error Codes 0 = file ist verfügbar -1 = file ist nicht verfügbar
begin

Timer1.Enabled := false;
 if ParamCount > 0 then
begin
   if paramCount = 1 then
  begin




    Path := trim(ParamStr(1)); // Trim the content of the Editbox to look for the path // Trimme den Inhalt der Editbox um nach den Pfad nachschauen zu können
    n := setPath(Path);
    edPfad.Text := ParamStr(1);
    // if the file doesn´t exist show a Message // Wenn die File nicht existiert, zeige eine Benachrichtigung an
    if not DirectoryExists(edPfad.Text) then
    begin
    ShowMessage('Pfad existiert nicht! Bitte wählen sie einen gültigen Pfad!');
    end;

      Delay(1000);
      List_item;        // list the itmes // Liste die Daten auf
      Delay(1000);
      btSearchProducts.Click;

  end;
end;


end;

end.
