unit SETXMLPATHunit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.Filectrl,
  Vcl.ComCtrls, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    butPathPc: TButton;
    edErrCode: TEdit;
    edPfad: TEdit;
    butExecute: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Timer1: TTimer;
    procedure butPathPcClick(Sender: TObject);
    function setPath(Path: AnsiString): Integer;
    procedure show_Results(n: Integer; Path : string);
    procedure butExecuteClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
uses uDLLdef;
{$R *.dfm}
{===============================================================================}
procedure TForm1.butExecuteClick(Sender: TObject);
var
  BuPath: string;
  mbYesNo: Integer;
  selDirect: boolean;
  vBuPath: string;
begin
  // Call the Directory// Directory aufrufen
  selDirect := SelectDirectory('Whlen Sie den gewnschten Pfad aus.', '', BuPath);
  // If not true close the Window // Wenn nicht wahr, Fenster schlieen
  if not selDirect then
  begin
    Exit;
  end
  else
  // Open the FolderBrowserDialog // FolderBrowserDialog ffnen
  begin
    vBuPath := 'Wollen Sie den Pfad:  ' + BuPath + #13 + 'bernehmen?';
    mbYesNo := MessageDlg(vBuPath, mtConfirmation, [mbYes, mbNo], 0);
    // if 'Yes' write the path in the variable and show it in the Editbox// wenn 'Ja' Pfad in Variable schreiben und in Edit-Feld anzeigen
    if mbYesNo = ID_YES then
    begin
      edPfad.Text := BuPath
    end
    else
    // if no stop the process and show a message// Wenn 'Nein' Verarbeitung stoppen, Fehlermeldung ausgeben
    begin
      application.messageBox('Die Verarbeitung wurde abgebrochen!', ' ', 0);
    end;

  end;

end;
{===============================================================================}
procedure TForm1.butPathPcClick(Sender: TObject);
var
  Path: AnsiString;
  n: LongInt;                  // n = number of the error code 0 = file is available -1 = file is not available // n = Nummer des Error Codes 0 = file ist verfgbar -1 = file ist nicht verfgbar
begin

    Path := trim(edPfad.Text); // Trim the content of the Editbox to look for the path // Trimme den Inhalt der Editbox um nach den Pfad nachschauen zu knnen
    n := setPath(Path);

    // if the file doesnt exist show a Message // Wenn die File nicht existiert, zeige eine Benachrichtigung an
    if not DirectoryExists(edPfad.Text) then

    ShowMessage('Pfad existiert nicht! Bitte whlen sie einen gltigen Pfad!');
end;
{===============================================================================}
procedure TForm1.show_Results(n: Integer; Path: string);
var
  l: LongInt;           // l = length of the path string (number of signs) // l = die Lnge des Pfad Strings (Anzahl der Zeichen)
begin

  l := length(Path);   // Set the length of the path // Setze die Lnge des Pfads
  if Path[l] = ';' then  // if there is a semcolon at the end // Wenn ein Semikolon am Ende steht
    delete(Path, l, 1);  // delete it // lsche es
  if fileExists(Path + '\Data.sqlite') then // if the file Data.sqlite exists edErrCode will show 0 // Wenn die file Data.sqlite existiert wird edErrCode eine 0 anzeigen
  begin
    edPfad.Text := Path;
    edErrCode.Text := intToStr(n);
  end
  else    // if not edErrCode will show -1 // wenn nicht, wird edErrCode eine -1 anzeigen
  begin
    edErrCode.Text := intToStr(-1);
    edPfad.Text := 'keine Datenbank vorhanden!  ' + Path + '\Data.sqlite'
  end;
end;
procedure TForm1.Timer1Timer(Sender: TObject);
var
  Path: AnsiString;
  n: LongInt;                  // n = number of the error code 0 = file is available -1 = file is not available // n = Nummer des Error Codes 0 = file ist verfgbar -1 = file ist nicht verfgbar
begin

Timer1.Enabled := false;
 if ParamCount > 0 then
begin
   if paramCount = 1 then
  begin




    Path := trim(ParamStr(1)); // Trim the content of the Editbox to look for the path // Trimme den Inhalt der Editbox um nach den Pfad nachschauen zu knnen
    n := setPath(Path);
    edPfad.Text := ParamStr(1);
    // if the file doesnt exist show a Message // Wenn die File nicht existiert, zeige eine Benachrichtigung an
    if not DirectoryExists(edPfad.Text) then
    begin
    ShowMessage('Pfad existiert nicht! Bitte whlen sie einen gltigen Pfad!');
    end;

  end;
end;

end;

{===============================================================================}
function TForm1.setPath(Path: AnsiString): Integer;
var
  l, n: LongInt;
  path_PAnsiChar: PAnsiChar;
  buffer: PAnsiChar;
begin
  n := -1;
  if fileExists(Path + '\Data.sqlite') then  // if the file Data.sqlite exists  // Wenn die file Data.sqlite existiert
  begin
    l := length(Path); // Set the length // Setze die Lnge
    if Path[l] <> ';' then   // if there is no semicolon at the end // Wenn kein Semikolon am Ende steht
      Path := Path + ';';    // Add a semicolon // Fge ein Semikolon hinzu
    GetMem(buffer, 4000);    // Get Free Memory for the function // Hole freien Speicher fr die Funktion
    buffer := PAnsiChar(Path); // write the path in the variable buffer (in Ansi code) // schreibe den Pfad in die Variable buffer (im Ansicode)
    n := uDLLdef.SET_XML_PATH_PC(buffer); // integrate the database with the program // Binde die Datenbank in das Programm ein
    show_Results(n, buffer);  // show the result // zeige das Ergebnis
  end
  else
  begin
    result := n;
  end;
end;


end.
